unit TeeChartMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, VCLTee.Series, Vcl.StdCtrls,
  Vcl.Samples.Spin, Vcl.ComCtrls;

type
  TfrmFastLine = class(TForm)
    chtFastLine: TChart;
    chsFastLine: TFastLineSeries;
    pnlControls: TPanel;
    btnRefill: TButton;
    spePoints: TSpinEdit;
    lblPoints: TLabel;
    stbPoints: TStatusBar;
    procedure btnRefillClick(Sender: TObject);
    procedure chtFastLineZoom(Sender: TObject);
    procedure chtFastLineUndoZoom(Sender: TObject);
    procedure chtFastLineScroll(Sender: TObject);
  private
    procedure UpdateStatusBar;
  public
  end;

var
  frmFastLine: TfrmFastLine;

implementation

{$R *.dfm}

procedure TfrmFastLine.btnRefillClick(Sender: TObject);
const MINUTES_PER_DAY = 1 / (60 * 24);
var
  dtmMin, dtmMax: TDateTime;
  Value: double;
  intPoint, intPoints: integer;
begin
  Self.chsFastLine.Clear;

  Randomize;
  intPoints := Self.spePoints.Value;
  dtmMin := Now;
  dtmMax := dtmMin + (intPoints * MINUTES_PER_DAY);
  Self.chtFastLine.BottomAxis.SetMinMax(dtmMin, dtmMax);

  Self.chsFastLine.AutoRepaint := False;
  for intPoint := 1 to intPoints do
    begin
      dtmMin := dtmMin + MINUTES_PER_DAY;
      Value := Random;
      Self.chsFastLine.AddXY(dtmMin, Value);
    end;
  Self.chsFastLine.AutoRepaint := True;

  Self.UpdateStatusBar;
end;

procedure TfrmFastLine.chtFastLineScroll(Sender: TObject);
begin
  Self.UpdateStatusBar;
end;

procedure TfrmFastLine.chtFastLineUndoZoom(Sender: TObject);
begin
  Self.UpdateStatusBar;
end;

procedure TfrmFastLine.chtFastLineZoom(Sender: TObject);
begin
  Self.UpdateStatusBar;
end;

procedure TfrmFastLine.UpdateStatusBar;
const strFORMAT = 'Displayed points: %d; '
  + 'first displayed index: %d; last displayed index: %d; '
  + 'first value index: %d; last value index %d';
begin
  Self.chsFastLine.CalcFirstLastVisibleIndex;
  Self.chsFastLine.CalcFirstLastVisibleIndex;
  Self.stbPoints.SimpleText := Format(strFORMAT, [Self.chsFastLine.VisibleCount,
    Self.chsFastLine.FirstDisplayedIndex, Self.chsFastLine.LastDisplayedIndex,
    Self.chsFastLine.FirstValueIndex, Self.chsFastLine.LastValueIndex]);
end;

end.
